unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  LazHelpHTML, Unit2, lclintf;       // inserire le seguenti Unit: Unit2, lclintf

type

  { TForm1 }

  TForm1 = class(TForm)
    BtnPermutazioni: TButton;
    BtnDisposizioniSemplici: TButton;
    BtnDisposizioniConRipetizione: TButton;
    BtnCombinazioniConRipetizione: TButton;
    BtnCombinazionizioniSenzaRipetizioni: TButton;
    BtnCancella: TButton;
    BtnTeoria: TButton;
    EdtRis: TEdit;
    EdtN: TEdit;
    EdtK: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LblLink: TLabel;
    procedure BtnCancellaClick(Sender: TObject);
    procedure BtnCombinazioniConRipetizioneClick(Sender: TObject);
    procedure BtnDisposizioniConRipetizioneClick(Sender: TObject);
    procedure BtnDisposizioniSempliciClick(Sender: TObject);
    procedure BtnCombinazionizioniSenzaRipetizioniClick(Sender: TObject);
    procedure BtnPermutazioniClick(Sender: TObject);
    procedure BtnTeoriaClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LblLinkClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

Var N_ , K_ , Ris: Integer ;

Function Fattoriale (N : Integer) : LongInt ;
Var i : Integer ; F : LongInt ;
begin
  F := 1 ;
  if (N <= 1) then F := 1
  else
    for i := 1 to N do F := F * i ;
  Fattoriale := F ;
end;

Function Potenza (B, E : Integer) : LongInt ;
Var i : Integer ; P : LongInt ;
begin
  P := 1 ;
  if (B = 0) then P := 0
  else
    for i := 1 to E do P := B * P ;
  Potenza := P ;
end;

Function Permutazioni (N : Integer) : LongInt ;
begin
  Permutazioni := Fattoriale(N);
end;

Function DisposizioniConRipetizione(N, K : Integer) : LongInt ;
begin
  DisposizioniConRipetizione := Potenza(N, K);
end;

Function DisposizioniSemplici(N, K : Integer) : LongInt ;
begin
  DisposizioniSemplici := Fattoriale(N) div Fattoriale(N - K) ;
end;

Function CombinazioniSenzaRipetizione(N, K : Integer) : LongInt ;
begin
  CombinazioniSenzaRipetizione := Fattoriale(N) div (Fattoriale(K) * Fattoriale(N - K)) ;
end;

Function CombinazioniConRipetizione(N, K : Integer) : LongInt ;
begin
  CombinazioniConRipetizione := Fattoriale(N + K - 1) div (Fattoriale(K) * Fattoriale(N - 1)) ;
end;

procedure TForm1.BtnPermutazioniClick(Sender: TObject);
begin
  N_ := StrToInt(EdtN.Text) ;
  Ris := Permutazioni(N_) ;
  EdtRis.Text := IntToStr(Ris) ;
end;

procedure TForm1.BtnCombinazioniConRipetizioneClick(Sender: TObject);
begin
  N_ := StrToInt(EdtN.Text) ;
  K_ := StrToInt(EdtK.Text) ;
  Ris := DisposizioniConRipetizione(N_, K_) ;
  EdtRis.Text := IntToStr(Ris) ;
end;

procedure TForm1.BtnDisposizioniConRipetizioneClick(Sender: TObject);
begin
  N_ := StrToInt(EdtN.Text) ;
  K_ := StrToInt(EdtK.Text) ;
  Ris := DisposizioniConRipetizione(N_, K_) ;
  EdtRis.Text := IntToStr(Ris) ;
end;

procedure TForm1.BtnDisposizioniSempliciClick(Sender: TObject);
begin
  N_ := StrToInt(EdtN.Text) ;
  K_ := StrToInt(EdtK.Text) ;
  Ris := DisposizioniSemplici(N_, K_) ;
  EdtRis.Text := IntToStr(Ris) ;
end;

procedure TForm1.BtnCombinazionizioniSenzaRipetizioniClick(Sender: TObject);
begin
  N_ := StrToInt(EdtN.Text) ;
  K_ := StrToInt(EdtK.Text) ;
  Ris := CombinazioniSenzaRipetizione(N_, K_) ;
  EdtRis.Text := IntToStr(Ris) ;
end;

procedure TForm1.BtnTeoriaClick(Sender: TObject);
begin
  OpenUrl('http://www.matematika.it/public/allegati/39/15_04_Calcolo_combinatorio_1_0.pdf') ;
  OpenUrl('http://utenti.quipo.it/base5/combinatoria/calcombinat.htm');
  OpenUrl('http://www.math.it/formulario/calcolo_combinatorio.htm');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LblLink.Cursor := crHandPoint;
  LblLink.Font.Color := clBlue;
  LblLink.Font.Style := [fsUnderline];
end;

procedure TForm1.LblLinkClick(Sender: TObject);
begin
  OpenUrl(LblLink.Caption) ;
end;

procedure TForm1.BtnCancellaClick(Sender: TObject);
begin
  EdtN.Clear ;  EdtK.Clear ;  EdtRis.Clear ;
end;

end.

